import pygame
import os
import numpy as np


pygame.init()
akna_laius=800
akna_kõrgus=800
äär = 160

aken= pygame.display.set_mode((akna_laius,akna_kõrgus))
clock = pygame.time.Clock()
pygame.key.set_repeat(0,20)

helesinine=(100,150,255)
sinine=(50,75,125)
valge=(255,255,255)
must=(0,0,0)
hall=(127,127,127)
punane = (255,50,50)
tumepunane = (150,50,50)
lilla = (150,10,180)

def constrain(n,_min,_max):
    return(min(max(n,_min),_max))

def rad(deg):
    return (deg * np.pi / 180)

def to_vect(kiirus, suund):
    suund = rad(suund)
    x = kiirus * np.cos(suund)
    y = kiirus * np.sin(suund)
    return([x,y])

def pic_load(path,x=40,y=40):
    if path:
        return pygame.image.load(path)
    else:
        pind = pygame.Surface((x,y))
        pygame.draw.rect(pind,lilla,(0,0,x,y))
        return(pind)

class Sprite_Sheet():
    def __init__(self,path):
        self.pic = pygame.image.load(path)
    def get_sprite(self, rectangle):
        rect = pygame.Rect(rectangle)
        pind = pygame.Surface(rect.size).convert()
        pind.set_colorkey(must)
        pind.blit(self.pic, (0,0),rect)
        pind.set_colorkey(must)
        return pind

class Liikur():
    def __init__(self,x,y,r=20, kiirus = 0, kiirendus=1, suund = 0, suuna_muutus = 0, pic = None):
        self.x=x
        self.y=y
        self.r=r
        
        self._kiirus = kiirus
        self.kiirendus = kiirendus
        self.suund = suund
        self.suuna_muutus = suuna_muutus
        
        self.kiirus = to_vect(self._kiirus,self.suund)
        
        self.pic = pic_load(None)
    def iterate(self):
        if self.suuna_muutus !=0 :
            self.suund += self.suuna_muutus
            self.kiirus = to_vect(self._kiirus,self.suund)
        
        self.kiirus = [i*self.kiirendus for i in self.kiirus]
        self._kiirus *= self.kiirendus
        
        
        
        self.x += self.kiirus[0]
        self.y += self.kiirus[1]
        self.collisionp()
        
    def redirect(self, suund, suuna_muutus = None, kiirus = None):
        if kiirus != None:
            self.kiirus = kiirus
        if suuna_muutus != None:
            self.suuna_muutus = suuna_muutus
        self.vect_kiirus = to_vect(kiirus,suund)
        
    def collisionp(self):
        self.player_col()
        self.edge_col()
    def player_col(self):
        pass
    def edge_col(self):
        if (self.x-self.r > akna_laius-äär or
            self.x+self.r < 0 or 
            self.y-self.r > akna_kõrgus or
            self.y-self.r < 0):
            return True
        return False
                
    def draw(self):
        aken.blit(self.pic, (self.x, self.y))
    
class Kuul(Liikur):
    def __init__(self,x,y,r=20, kiirus = 0, kiirendus=1, suund = 0, suuna_muutus = 0, pic = None):
        super().__init__(x,y,r=r,kiirus=kiirus,kiirendus=kiirendus,suund=suund,suuna_muutus=suuna_muutus)
        self.live = True
        if pic != None:
            print(1)
            self.pic = pic
        else:
            print(2)
    def collisionp(self):   
        if self.edge_col():
            self.live = False
            print("bullet gone")
    def player_col(self):
        return False
        
            
            

class Player():
    def __init__(self,
                    x = 320,
                    y = 720,
                    lives = 3,
                    speed = 20,
                    tegelane = "Bob"
                    ):
        self.tegelane = tegelane
        self.x = x
        self.y = y
        self.lives = lives
        self.speed = speed
        self.pic = pic_load(os.path.join("Tegelased",tegelane+".png"))
        self.kast=pygame.Rect(self.y, self.x, 40,40)
    def draw(self):
        aken.blit(self.pic, (self.x, self.y))
        
        
def Main():
    Kuulid = Sprite_Sheet("Kuulid.png")
    
    pause = False
    
    dist=0
    
    Mina = Player()
    kuul = Kuul(200,200,r=20, kiirus=5,kiirendus=1.0,suund=90,suuna_muutus=0, pic = Kuulid.get_sprite((40,0,40,40)))
    
    asjad=[kuul]
    
    while True:
        
        keys = pygame.key.get_pressed()
        mouse_pos=pygame.mouse.get_pos()
        
        if pause:
            for event in pygame.event.get():
                if event.type == pygame.KEYDOWN:
                    #Pause/unpause
                    if event.key == pygame.K_SPACE:
                        pause = not pause
        else:
            
            speed = Mina.speed / (1 + keys[pygame.K_LSHIFT]*2)
            
            if keys[pygame.K_UP]:
                Mina.y -= speed
            if keys[pygame.K_DOWN]:
                Mina.y += speed
            if keys[pygame.K_LEFT]:
                Mina.x -= speed
            if keys[pygame.K_RIGHT]:
                Mina.x += speed
            Mina.x = constrain(Mina.x,0,600)
            Mina.y = constrain(Mina.y,0,760)
            
            for event in pygame.event.get():
                    #Lahkub mängust, kui aken kinni nupp
                    if event.type == pygame.QUIT:                
                        pygame.quit()
                        exit()
                    #Klahvivajutused
                    elif event.type == pygame.KEYDOWN:
                        #Avab lahkumise menüü kui ESC
                        if event.key == pygame.K_ESCAPE:
                            pygame.quit()
                            exit()
                        #Pause/unpause
                        if event.key == pygame.K_SPACE:
                            pause = not pause
                        
        for asi in asjad.copy():
            if asi.live != True:
                asjad.remove(asi)
                print(vars(asi))
                del asi
            else:
                asi.iterate()
                
                        
        aken.fill(helesinine)
        
        for asi in asjad:
            asi.draw()
        Mina.draw()
            

        pygame.draw.rect(aken, hall, (akna_laius-äär,0,äär,akna_kõrgus))
        
        
        
        
        pygame.display.flip()
        clock.tick(30)

try:
    Main()
finally:
    pygame.quit()
