import pygame
pygame.init()
akna_laius=800
akna_kõrgus=800
aken= pygame.display.set_mode((akna_laius,akna_kõrgus))
clock = pygame.time.Clock()
pygame.key.set_repeat(300,20)

helesinine=(100,150,255)
sinine=(50,75,125)
valge=(255,255,255)
must=(0,0,0)
punane = (255,50,50)
tumepunane = (150,50,50)
akna_põrge = 0.9

def gradient(rect, col1,col2, angle=0):
    x,y,laius,kõrgus=rect
    x2=x+laius
    vahed=[col1[i]-col2[i] for i in range(3)]
    for i in range(kõrgus):
        reaCol=tuple(col1[j]-vahed[j]*i/kõrgus for j in range(3))
        pygame.draw.line(aken,reaCol,(x,y+i),(x2,y+i))

#Tagastab ristküliku alguspunkti ja küljepikkused kahest punktist
def get_rect(a,b): 
    return((min(a[0],b[0]),min(a[1],b[1]),abs(a[0]-b[0]),abs(a[1]-b[1])))

class liikur():
    def __init__(self,x,y,kiirus=[0,0], kiirendus=[0,0]):
        self.x=x
        self.y=y
        self.kiirus=kiirus
        self.kiirendus = kiirendus
    def iterate(self):
        self.x += self.kiirus[0]
        self.y += self.kiirus[1]
        self.collisionp()
        self.kiirus = [self.kiirus[i] + self.kiirendus[i] for i in [0,1]]
    def collisionp(self):
        return
    def draw(self):
        return

class pall(liikur):
    def __init__(self,x,y,r,värv,kiirus=[0,0],kiirendus=[0,1]):
        super().__init__(x,y,kiirus=kiirus,kiirendus=kiirendus)
        self.r=r
        self.värv=värv
    def draw(self):
        pygame.draw.circle(aken,self.värv, (self.x,self.y),self.r)
    def collisionp(self):
        self.edge_col() 
        
    
    def edge_col(self):
        if self.x+self.r > akna_laius:
            self.x = akna_laius - self.r
            self.kiirus[0] *= -akna_põrge
        if self.x-self.r < 0:
            self.x = self.r
            self.kiirus[0] *= -akna_põrge
        if self.y+self.r > akna_kõrgus:
            self.y = akna_kõrgus - self.r
            self.kiirus[1] *= -akna_põrge
        if self.y-self.r < 0:
            self.y = self.r
            self.kiirus[1] *= -akna_põrge
            
        


def sim(rate):
    kera = pall(400, 30,20,tumepunane, kiirus=[10,0])
    build_mode="rect"
    build_queue=[]
    new_rects=[]
    pause = 1
    
    while True:
        
        mouse_pos=pygame.mouse.get_pos()
        
        for event in pygame.event.get():
                #Lahkub mängust, kui aken kinni nupp
                if event.type == pygame.QUIT:                
                    pygame.quit()
                    exit()
                #Klahvivajutused
                elif event.type == pygame.KEYDOWN:
                    #Avab lahkumise menüü kui ESC
                    if event.key == pygame.K_ESCAPE:
                        pygame.quit()
                        exit()
                    #Pause/unpause
                    if event.key == pygame.K_SPACE:
                        pause = 1 - pause
                    if event.key == pygame.K_UP:
                        rate *= 2
                    if event.key == pygame.K_DOWN:
                        rate =30
                elif event.type == pygame.MOUSEBUTTONDOWN:
                    print(mouse_pos)
                    if build_queue == []:
                        build_queue.append(mouse_pos)
                    elif build_mode == "rect":
                        new_rects.append(get_rect(build_queue[0],mouse_pos))
                        build_queue=[]
                                    
                    
        if not pause:                      
            kera.iterate()
        
        aken.fill(valge)
        #gradient((100,100,200,200),helesinine,must)
        kera.draw()
        
        #Ristkülikud       
        for rect in new_rects:
            pygame.draw.rect(aken, helesinine, rect)
        #Ääred
        for rect in new_rects:
            pygame.draw.rect(aken, sinine, rect, 5)
        #Parajasti loodav ristkülik
        if build_mode == "rect" and build_queue != [] :
            pygame.draw.rect(aken,sinine,get_rect(build_queue[0],mouse_pos),5)

            
        pygame.display.flip()
        clock.tick(rate)
        
try:
    sim(30)
finally:
    pygame.quit()