(defun split (num len
	      &optional (olemas (make-array 9 :fill-pointer 0)))
  "Vaatab, kuidas on võimalik arvu len numbriks jagada"
  (cond
    ((= len 1) num)
    ((= len 2)
     (loop for n from 1 to 9
	   unless (or (not (< 0 n (- num n) 10))
		      (find n olemas)
		      (find (- num n) olemas))
	     collecting (cons n (cons (- num n) nil))))
    (t
     (unpack 
      (loop for n from 1 to 9
	    unless (find n olemas)
	      if (>=
		  (slice 0 (1- len) olemas :from-end t) ; Maks väärtus ruutudel
		  (- num n )
		  (slice 0 (1- len) olemas)) ; Min väärtus ruutudel
		do  
		   (setf olemas (concatenate 'vector olemas (vector n)))
		and
		  collect (loop for var in
					(split (- num n) (1- len)
					       (copy-seq olemas))
				collect (cons n var)))))))

(defun slice (a b olemas &key (from-end nil))
  "Ruudus leiduvate numbrite summa a-b"
  (let ((alles
	  (remove-if (lambda (x) (find x olemas))
		     #(1 2 3 4 5 6 7 8 9))))
    (cond ((< (- b a) (length alles))
	   (reduce #'+ (subseq
		 (if from-end (reverse alles) alles)
		 a b)))
	  ((null from-end) 100)
	  (t -1))))
(defun unpack (crowded)
  (let ((a (cons 1 nil)))
    (dolist (b crowded (rest a))
      (nconc a b))))

(defun ilus-split ()
  "Küsib split asju ilusti"
  (loop
    (let ((num (progn (format t "Jagunev arv: ")
		      (read)))
	  (len (progn (format t "Ruutude arv: ")
		      (read)))
	  (olemas (progn (format t "Olemasolevad arvud :")
			 (read-from-string (format nil "#(~a)" (read-line))))))
      (decf num (reduce #'+ olemas))
      (decf len (length olemas))
      (format t "~a~%" (split num len olemas);(loop for var in (split num len olemas)
					;collect (concatenate 'list olemas var))
	      ))))


897

(defun range (&key (n 9))
  (loop for i from 1 upto n collecting i))

(defun exclude (nums rem)
  "Eemaldab vektorist nums numbri rem, kui alles vaid üks number, teeb numbriks"
  (remove rem nums)
  (if (= (length nums) 1)
      (elt nums 0)
      nums))

(defun nono-fit (lens line-len
		 &key (line (make-array line-len :initial-element 0 )))
  (loop
    ;Kui palju ruumi kõik numbrid ja nende vahed võtaks
    with kogu = (+ (reduce #'+ lens) (length lens) -1)
    for ees = 0 then (+ ees len 1)
    for järel = kogu then (- järel len 1)
    for len across lens do (pprint (list kogu ees järel len))
    if (> (* len 2) (- line-len (- kogu len) ))
      do (loop for i
	       from (- line-len järel -1)
		 to (+ ees len )
	       do 
		  (setf (elt line (1- i)) 1)))
    line)

(loop for i across #(1 2 5 6) summing i)

(defparameter *test-array* #(#(3 6 9) #(2 4 8 16) #(5 25)))

(defparameter *nono-test* #(#(1 1) #(4 1) #(4 3 2 1) #(1 4 1 1 1) #(3 1 1) #(3 2 6) #(1 2 3) #(4 1) #(2 1) #(5) #(1 4) #(1 2 2) #(1 5) #(4 2) #(2 5)))
 

(defun deb (x)
  (pprint x)
  x)


(defun deep-array (lis n)
  "Turns nested lists into arrays"
  (if (= n 1)
      (coerce lis 'vector)
      (coerce (loop for i in lis collecting (deep-array i (1- n)))
	      'vector)))

(defun longest-sub (vector)
  "returns the length of the vectors longest element"
  (loop for x across vector maximize (length x)))

(defun safe-elt (vector index &key ((:default def) 0))
  (if (> (length vector) index)
      (elt vector index)
      def))

(defun invert-array (array)
  "returns the array with rows and columns switched"
  (deep-array
   (loop for i upto (1- (longest-sub array))
	 collecting (loop for j across array
			  collecting (safe-elt (reverse j) i)))
   2))

(defun nono-column (column)
  "Puts | between columns "
  (loop for n across column
	collecting
	(cond
	  ((zerop n)
	   " |")
	  ((> n 9)
	   (format nil "~a" n))
	  (t
	   (format nil "~a|" n)))))


(defun nono-top (top-array left-pad)
  "returns a string version of the top clues in a nonogram"
  (format nil 
	  (format nil "~~{~~~at|~~{~~a~~}~~%~~}" left-pad)
					;"~{~vt|~{~a~}~%~}"
	  (reverse (loop for column across (invert-array top-array)
				 collecting (nono-column column)))))
	



(defclass ruudustik ()
  ((suurus
    :initarg :suurus
    :initform '(1 . 1))
   (kuju 
    :initarg :kuju
    :initform "ruut")))



"
X - - - X
| \  41 |
|   \   |
| 24  \ |
X - - - X

X - - X
| \ 45|
| 24\ |
X - - X

X - - X
|12345|
|6789 |
X - - X

X - - - X
| 1 2 3 |
| 4 5 6 |
| 7 8 9 |
X - - - X

X X X X X
X  /⁀\  X
X    /  X
X    /__ X    
X X X X X

X - - - X
|   ⁄|   |
|   |   |
|  _|_  |
X - - - X

█████████
█  _    █
█  _\   █
█  _/   █
█████████

X X X X X
X   /|  X
X  /_|_ X
X    |  X
X X X X X

X X X X X
X  |¯¯  X
X  |_   X
X   _J  X
X X X X X
¬
■
   4| | | |
   112|3| |
  XX X X X X X X X
  X■ ■ ■ ■
  X■ ■ ■ ■
  X■
  X■
  X
  X■
  XX X X X X X



1 2 3 44 |
  3 4  4 |
         |


1 2 3 44 |
   3 4 4 |
         |



"


